## xdaliclock 2.18

=== Makefile ===
# xdaliclock, Copyright (c) 1999 Jamie Zawinski.

SHELL		= /bin/sh
TARFILES	= README Makefile version.h xdaliclock.lsm \
		  config.guess config.sub install-sh
NUMBERS		= numbers0/*.xbm numbers1/*.xbm \
		  numbers2/*.xbm numbers3/*.xbm
TAR		= tar
COMPRESS	= gzip --verbose --best
COMPRESS_EXT	= gz


default:
	@echo ''; \
	 echo '        please make one of: "x", "palm", "all", or "clean"'; \
	 echo ''; \
	 exit 5

all: X11 palm

X11::   x11
X::     X11
x::     X11
palm::  Palm
pilot:: Palm
Pilot:: Palm

x11: X11/Makefile
	@echo '==============================================================='
	@echo ''
	cd X11 ; make

Palm: palm/Makefile
	@echo '==============================================================='
	@echo ''
	cd palm ; make

X11/Makefile:
	@echo '==============================================================='
	@echo ''
	cd X11 ; ./configure

palm/Makefile:
	@echo '==============================================================='
	@echo ''
	cd palm ; ./configure

clean: X11/Makefile palm/Makefile
	cd X11 ; make $@
	cd palm ; make $@

distclean: X11/Makefile palm/Makefile
	cd X11 ; make $@
	cd palm ; make $@

tar: X11/Makefile palm/Makefile
	@								    \
  for dir in X11 palm ; do						    \
   ( cd $$dir ;								    \
     rm -f configure ;							    \
     autoconf ;								    \
     ./config.status ;							    \
     $(MAKE) distdepend );						    \
  done ;								    \
  sh xdaliclock.lsm.sh > xdaliclock.lsm.$$$$ ;				    \
  mv xdaliclock.lsm.$$$$ xdaliclock.lsm ;				    \
  (cd X11; make update_spec_version) ;					    \
  (cd palm; make update_rsc_version) ;					    \
  NAME=`sed -n								    \
  's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
  rm -rf $$NAME ; ln -s . $$NAME ;					    \
  FILES= ;								    \
  for subdir in X11 palm ; do						    \
    d=`pwd` ;								    \
    cd $$subdir ;							    \
    FILES="$$FILES `$(MAKE) echo_tarfiles				    \
      | grep -v '^.*make\['						    \
      | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
      ` ";								    \
    cd $$d ; done ;							    \
  echo creating tar file $${NAME}.tar.$(COMPRESS_EXT)... ;		    \
  $(TAR) -vchf -							    \
    `echo $(TARFILES) $$FILES $(NUMBERS)				    \
   | sed "s|^|$$NAME/|g; s| | $$NAME/|g" `				    \
   | $(COMPRESS) > $${NAME}.tar.$(COMPRESS_EXT) ;			    \
  rm $$NAME ;								    \
  ls -ldF $${NAME}.tar.$(COMPRESS_EXT)

www::
	@								    \
  DEST=$$HOME/www/xdaliclock ;						    \
  VERS=`sed -n 's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/\1/p' version.h`	 ;  \
  VERS2=`echo $$VERS | sed 's/[.]//g'`					 ;  \
  HEAD="daliclock-$$VERS"						 ;  \
  HEAD2="daliclock-$$VERS2"						 ;  \
  TAR="x$$HEAD.tar.gz"							 ;  \
  PRC="$$HEAD2.prc"							 ;  \
  ZIP="$$HEAD2.zip"							 ;  \
									    \
  if [ ! -f $$TAR ]; then						    \
    echo "$$TAR does not exist!  Did you forget to \`make tar'?" ;	    \
    exit 1 ; 								    \
  fi ;									    \
  chmod a-w $$TAR ;							    \
  if [ -f $$DEST/$$TAR ]; then						    \
    echo -n "WARNING: $$DEST/$$TAR already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
  if [ -f $$DEST/$$PRC ]; then						    \
    echo -n "WARNING: $$DEST/$$PRC already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
  cp -p $$TAR $$DEST/$$TAR ;						    \
  chmod u+w $$DEST/$$TAR ;						    \
  cp -p palm/daliclock.prc $$DEST/$$PRC ;				    \
  cd $$DEST ;								    \
									    \
  rm -f $$ZIP ;								    \
  zip -q9 $$ZIP $$PRC ;							    \
									    \
  TMP=/tmp/xd.$$$$ ;							    \
  sed -e "s/daliclock-[0-9]\.[0-9][0-9]*/$$HEAD/g"			    \
      -e "s/daliclock-[0-9][0-9][0-9]*/$$HEAD2/g" index.html > $$TMP ;	    \
  echo '' ;								    \
  diff -u0 index.html $$TMP ;						    \
  echo '' ;								    \
									    \
  OLDEST=`ls xdaliclock*.tar.gz | head -1` ;				    \
  echo -n "Delete $$DEST/$$OLDEST? ";					    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST ;							    \
    cvs remove $$OLDEST ;						    \
    set +x ;								    \
  fi ;									    \
									    \
  OLDEST=`ls daliclock*.prc | head -1` ;				    \
  OLDEST2=`echo $$OLDEST | sed 's/prc/zip/'` ;				    \
  echo -n "Delete $$DEST/$$OLDEST and $$DEST/$$OLDEST2? ";		    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST $$OLDEST2 ;						    \
    cvs remove $$OLDEST $$OLDEST2 ;					    \
  else									    \
    set -x ;								    \
  fi ;									    \
									    \
  cvs add -kb $$TAR $$PRC $$ZIP ;					    \
  set +x ;								    \
									    \
  cat $$TMP > index.html ;						    \
  rm -f $$TMP ;								    \
									    \
  cvs commit -m "$$VERS"

## xdaliclock 2.20

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,9 @@
-# xdaliclock, Copyright (c) 1999 Jamie Zawinski.
+# xdaliclock, Copyright (c) 1991-2002 by Jamie Zawinski.
 
 SHELL		= /bin/sh
 TARFILES	= README Makefile version.h xdaliclock.lsm \
-		  config.guess config.sub install-sh
+		  config.guess config.sub install-sh \
+		  mac128/README mac128/*.*
 NUMBERS		= numbers0/*.xbm numbers1/*.xbm \
 		  numbers2/*.xbm numbers3/*.xbm
 TAR		= tar
@@ -43,7 +44,7 @@
 palm/Makefile:
 	@echo '==============================================================='
 	@echo ''
-	cd palm ; ./configure
+	cd palm ; ./configure --host=m68k-palmos --build=`../config.guess`
 
 clean: X11/Makefile palm/Makefile
 	cd X11 ; make $@
@@ -52,6 +53,15 @@
 distclean: X11/Makefile palm/Makefile
 	cd X11 ; make $@
 	cd palm ; make $@
+
+install:
+	@echo ''; \
+	 echo '        to install the X version: "cd X11; make install".';   \
+	 echo ''; \
+	 echo '        to install the Palm version: "cd palm; make", and';   \
+	 echo '        then download "daliclock.prc" to your PalmOS device.';\
+	 echo ''; \
+	 exit 5
 
 tar: X11/Makefile palm/Makefile
 	@								    \
@@ -78,13 +88,13 @@
       | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
       ` ";								    \
     cd $$d ; done ;							    \
-  echo creating tar file $${NAME}.tar.$(COMPRESS_EXT)... ;		    \
+  echo creating tar file archive/$${NAME}.tar.$(COMPRESS_EXT)... ;	    \
   $(TAR) -vchf -							    \
     `echo $(TARFILES) $$FILES $(NUMBERS)				    \
    | sed "s|^|$$NAME/|g; s| | $$NAME/|g" `				    \
-   | $(COMPRESS) > $${NAME}.tar.$(COMPRESS_EXT) ;			    \
+   | $(COMPRESS) > archive/$${NAME}.tar.$(COMPRESS_EXT) ;		    \
   rm $$NAME ;								    \
-  ls -ldF $${NAME}.tar.$(COMPRESS_EXT)
+  ls -ldF archive/$${NAME}.tar.$(COMPRESS_EXT)
 
 www::
 	@								    \
@@ -97,11 +107,11 @@
   PRC="$$HEAD2.prc"							 ;  \
   ZIP="$$HEAD2.zip"							 ;  \
 									    \
-  if [ ! -f $$TAR ]; then						    \
-    echo "$$TAR does not exist!  Did you forget to \`make tar'?" ;	    \
+  if [ ! -f archive/$$TAR ]; then					    \
+    echo "archive/$$TAR does not exist!  Did you forget to \`make tar'?" ;  \
     exit 1 ; 								    \
   fi ;									    \
-  chmod a-w $$TAR ;							    \
+  chmod a-w archive/$$TAR ;						    \
   if [ -f $$DEST/$$TAR ]; then						    \
     echo -n "WARNING: $$DEST/$$TAR already exists!  Overwrite? ";	    \
     read line;								    \
@@ -116,7 +126,7 @@
       exit 1 ; 								    \
     fi ;								    \
   fi ;									    \
-  cp -p $$TAR $$DEST/$$TAR ;						    \
+  cp -p archive/$$TAR $$DEST/$$TAR ;					    \
   chmod u+w $$DEST/$$TAR ;						    \
   cp -p palm/daliclock.prc $$DEST/$$PRC ;				    \
   cd $$DEST ;								    \

## xdaliclock 2.23

=== OSX/Makefile ===
# Dali Clock for MacOS X, Copyright (c) 2005-2006 by Jamie Zawinski.

XCODEPROJ = DaliClock

default: deployment
all: deployment debug

clean:
	xcodebuild -target "$(XCODEPROJ)" clean

distclean:
	-rm -f Makefile config.status config.cache config.log \
	  *.bak *.rej TAGS *~ "#"*
	-rm -rf autom4te*.cache
	-rm -rf build

deployment:
	xcodebuild -target "$(XCODEPROJ)" -configuration Deployment  build

debug:
	xcodebuild -target "$(XCODEPROJ)" -configuration Development build

echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name build -o -name CVS -o -name '*~*' \
	     -o -name 'jwz.*' \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`

update_plist_version:
	@S=Info.plist ;							    \
	V=`sed -n 's/.*\([0-9][0-9]*\.[0-9]*\).*/\1/p' < ../version.h` ;    \
	echo -n "Updating version number in $$S to \"$$V\"... " ;	    \
	T=/tmp/xs.$$$$ ;						    \
	sed "s@\(<string>\)2\.[0-9][0-9]*@\1$$V@"			    \
	  < $$S > $$T ;							    \
	if cmp -s $$S $$T ; then					    \
	  echo "unchanged." ;						    \
	else								    \
	  cat $$T > $$S ;						    \
	  echo "done." ;						    \
	fi ;								    \
	rm $$T

## xdaliclock 2.24

=== OSX/Makefile ===
# Dali Clock for MacOS X, Copyright (c) 2005-2007 by Jamie Zawinski.

XCODEPROJ = All Targets

default: release
all: debug release

clean:
	-rm -rf build
#	cd ..; xcodebuild -target "$(XCODEPROJ)" clean

distclean:
	-rm -f config.status config.cache config.log \
	  *.bak *.rej TAGS *~ "#"*
	-rm -rf autom4te*.cache
	-rm -rf build

debug: distdepend
	xcodebuild -target "$(XCODEPROJ)" -configuration Debug   build

release: distdepend
	xcodebuild -target "$(XCODEPROJ)" -configuration Release build

echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name build -o -name CVS -o -name '*~*' \
	     -o -name 'jwz.*' \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`

distdepend:: update_bindist_version
update_bindist_version:
	@								    \
  SS="bindist.rtf" ;							    \
  U=../version.h ;							    \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		    \
  D=`date '+%d-%b-%Y'` ;						    \
  for S in $$SS ; do							    \
   T=/tmp/xs.$$$$ ;							    \
   sed -e "s/\(.*version \)[0-9][0-9]*\.[0-9]*[ab]*[0-9]*\(.*\)/\1$$V\2/"   \
       -e "s/\([0-9][0-9]-[A-Z][a-z][a-z]-[0-9][0-9][0-9]*\)/$$D/"	    \
      < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
    true ;								    \
   else									    \
    cat $$T > $$S ;							    \
    echo "updated $$S to $$V $$D" ;					    \
   fi ;									    \
  done ;								    \
  rm $$T

distdepend:: update_plist_version
update_plist_version:
	@SS="AppInfo.plist SaverInfo.plist";				    \
  SRC=../version.h ;							    \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' $$SRC` ;		    \
  for S in $$SS ; do							    \
   echo -n "Updating version number in $$S to \"$$V\"... " ;		    \
   T=/tmp/xs.$$$$ ;							    \
   KEYS1="CFBundleVersion|CFBundleShortVersionString" ;			    \
   KEYS2="NSHumanReadableCopyright|CFBundleLongVersionString|CFBundleGetInfoString" ; \
   perl -0777 -pne							    \
 "s@(<key>($$KEYS1)</key>\s*<string>)[\d.]+(</string>)@\$${1}$$V\$${3}@gs;  \
  s@(<key>($$KEYS2)</key>\s*<string>[^\d]+)[\d.]+(.*?</string>)@\$${1}$$V\$${3}@gs" \
    < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
     echo "unchanged." ;						    \
   else									    \
    cat $$T > $$S ;							    \
    echo "done." ;							    \
   fi ;									    \
   rm $$T ;								    \
  done


# -format UDBZ saves 4% over UDZO, but that's only 8KB.
dmg:: distdepend
	@								      \
  set -e ;								      \
  SRC=../version.h ;							      \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' $$SRC` ;		      \
  V=`echo $$V | sed 's/\.//g'` ;					      \
  TMPDIR="build" ;							      \
  SRC="build/Release" ;							      \
  BASE="daliclock-$$V" ;						      \
  OUTDIR="../archive" ;							      \
  DMG="$$OUTDIR/$$BASE.dmg" ;						      \
  TMPDMG="$$TMPDIR/tmp.dmg" ;						      \
  VOLNAME="DaliClock $$V" ;						      \
  STAGE="$$TMPDIR/dmg_stage" ;						      \
  rm -f "$$DMG" ;							      \
  rm -rf "$$STAGE" ;							      \
  echo + mkdir "$$STAGE" ;						      \
         mkdir "$$STAGE" ;						      \
  FILES="$$SRC/*.app $$SRC/*.saver ../palm/daliclock.prc" ;		      \
  echo + cp -pr $$FILES "$$STAGE" ;					      \
         cp -pr $$FILES "$$STAGE" ;					      \
  set -x ;								      \
  cp -p bindist.rtf "$$STAGE/ READ ME.rtf" ;				      \
  cp -p bindist-DS_Store "$$STAGE/.DS_Store" ;				      \
  /Developer/Tools/SetFile -a E "$$STAGE/ READ ME.rtf" ;		      \
  /Developer/Tools/SetFile -a e $$STAGE/*.saver $$STAGE/*.prc ;		      \
  seticon -d daliclockPRC.icns $$STAGE/*.prc ;				      \
  seticon -d daliclockSaver.icns $$STAGE/*.saver ;			      \
  hdiutil makehybrid -quiet -ov -hfs -hfs-volume-name "$$VOLNAME"	      \
    -hfs-openfolder "$$STAGE" "$$STAGE" -o "$$TMPDMG" ;			      \
  rm -rf "$$STAGE" ;							      \
  hdiutil convert -quiet -ov -format UDZO -imagekey zlib-level=9	      \
    "$$TMPDMG" -o "$$DMG" ;						      \
  rm -f "$$TMPDMG" ;							      \
  ls -ldhgF "$$DMG"

# Adding this is cute:
#    hdiutil internet-enable -yes -quiet "$$DMG"
# but means that nobody will ever see the display settings I used!
# When finder copies the .dmg to a folder, it doesn't preserve them.

## xdaliclock 2.25

=== Makefile ===
# xdaliclock, Copyright (c) 1991-2006 by Jamie Zawinski.

SHELL		= /bin/sh
TARFILES	= README Makefile version.h \
		  config.guess config.sub install-sh \
		  mac128/README mac128/*.*
NUMBERS		= numbers0/*.xbm numbers1/*.xbm numbers2/*.xbm \
		  numbers_big/README numbers_big/*.gif numbers_big/*.xbm
TAR		= tar
COMPRESS	= gzip --verbose --best
COMPRESS_EXT	= gz


default:
	@echo ''; \
	 echo '        please make one of: "x", "palm", "all", or "clean"'; \
	 echo ''; \
	 exit 5

all: X11 palm

X11::   x11
X::     X11
x::     X11
gtk::   GTK
OSX::   osx
palm::  Palm
pilot:: Palm
Pilot:: Palm

x11:: X11/Makefile
	@echo '==============================================================='
	@echo ''
	cd X11 ; make

GTK:: gtk/Makefile
	@echo '==============================================================='
	@echo ''
	cd gtk ; make

osx::
	@echo '==============================================================='
	@echo ''
	cd OSX ; make

Palm:: palm/Makefile
	@echo '==============================================================='
	@echo ''
	cd palm ; make

X11/Makefile:
	@echo '==============================================================='
	@echo ''
	cd X11 ; ./configure

gtk/Makefile:
	@echo '==============================================================='
	@echo ''
	cd gtk ; ./configure

palm/Makefile:
	@echo '==============================================================='
	@echo ''
	cd palm ; ./configure --host=m68k-palmos --build=`../config.guess`

clean: X11/Makefile palm/Makefile
	cd X11 ; make $@
	cd gtk ; make $@
	cd OSX ; make $@
	cd palm ; make $@

distclean: X11/Makefile gtk/Makefile palm/Makefile
	cd X11 ; make $@
	cd gtk ; make $@
	cd OSX ; make $@
	cd palm ; make $@

install:
	@echo ''; \
	 echo '      - to install the X11 version: "cd X11; make install".';   \
	 echo ''; \
	 echo '      - to install the MacOS version: "cd OSX; make"';	     \
	 echo '        then copy "build/Development/DaliClock.app"';	     \
	 echo '        to your Applications folder."';			     \
	 echo ''; \
	 echo '      - to install the Palm version: "cd palm; make", and';   \
	 echo '        then download "daliclock.prc" to your PalmOS device.';\
	 echo ''; \
	 exit 5

tar: X11/Makefile gtk/Makefile palm/Makefile
	@								    \
  for dir in X11 gtk palm ; do						    \
   ( cd $$dir ;								    \
     rm -f configure ;							    \
     autoconf ;								    \
     ./config.status ;							    \
     $(MAKE) distdepend );						    \
  done ;								    \
  (cd X11; make update_spec_version) ;					    \
  (cd gtk; make update_spec_version) ;					    \
  (cd palm; make update_rsc_version) ;					    \
  (cd OSX; make update_plist_version) ;					    \
  NAME=`sed -n								    \
  's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
  rm -rf $$NAME ; ln -s . $$NAME ;					    \
  FILES= ;								    \
  for subdir in X11 gtk palm OSX ; do					    \
    d=`pwd` ;								    \
    cd $$subdir ;							    \
    FILES="$$FILES `$(MAKE) echo_tarfiles				    \
      | grep -v '^.*make\['						    \
      | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
      ` ";								    \
    cd $$d ; done ;							    \
  echo creating tar file archive/$${NAME}.tar.$(COMPRESS_EXT)... ;	    \
  $(TAR) -vchf -							    \
    `echo $(TARFILES) $$FILES $(NUMBERS)				    \
   | sed "s|^|$$NAME/|g; s| | $$NAME/|g" `				    \
   | $(COMPRESS) > archive/$${NAME}.tar.$(COMPRESS_EXT) ;		    \
  rm $$NAME ;								    \
  ls -ldF archive/$${NAME}.tar.$(COMPRESS_EXT)

www::
	@								    \
  DEST=$$HOME/www/xdaliclock ;						    \
  VERS=`sed -n 's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/\1/p' version.h`	 ;  \
  VERS2=`echo $$VERS | sed 's/[.]//g'`					 ;  \
  HEAD="daliclock-$$VERS"						 ;  \
  HEAD2="daliclock-$$VERS2"						 ;  \
  HEAD3="DaliClock-$$VERS2"						 ;  \
  TAR="x$$HEAD.tar.gz"							 ;  \
  PRC="$$HEAD2.prc"							 ;  \
  DMG="$$HEAD3.dmg"							 ;  \
									    \
  if [ ! -f archive/$$TAR ]; then					    \
    echo "archive/$$TAR does not exist!  Did you forget to \`make tar'?" ;  \
    exit 1 ; 								    \
  fi ;									    \
									    \
  if [ ! -f archive/$$DMG ]; then					    \
    echo "archive/$$DMG does not exist!  Did you forget to \`make dmg'?" ;  \
    exit 1 ; 								    \
  fi ;									    \
  chmod a-w archive/$$TAR ;						    \
  chmod a-w archive/$$DMG ;						    \
									    \
  if [ -f $$DEST/$$TAR ]; then						    \
    /bin/echo -n "WARNING: $$DEST/$$TAR already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
									    \
  if [ -f $$DEST/$$PRC ]; then						    \
    /bin/echo -n "WARNING: $$DEST/$$PRC already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
									    \
  if [ -f $$DEST/$$DMG ]; then						    \
    /bin/echo -n "WARNING: $$DEST/$$DMG already exists!  Overwrite? ";	    \
    read line;								    \
    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
      exit 1 ; 								    \
    fi ;								    \
  fi ;									    \
									    \
  cp -p archive/$$TAR $$DEST/$$TAR ;					    \
  chmod u+w $$DEST/$$TAR ;						    \
									    \
  cp -p archive/$$DMG $$DEST/$$DMG ;					    \
  chmod u+w $$DEST/$$DMG ;						    \
									    \
  cp -p palm/daliclock.prc $$DEST/$$PRC ;				    \
  cd $$DEST ;								    \
									    \
  TMP=/tmp/xd.$$$$ ;							    \
  sed -e "s/daliclock-[0-9]\.[0-9][0-9]*/$$HEAD/g"			    \
      -e "s/daliclock-[0-9][0-9][0-9]*/$$HEAD2/g"			    \
      -e "s/DaliClock-[0-9][0-9][0-9]*/$$HEAD3/g"			    \
      index.html > $$TMP ;						    \
  echo '' ;								    \
  diff -U0 index.html $$TMP ;						    \
  echo '' ;								    \
									    \
  OLDEST=`ls xdaliclock*.tar.gz | head -1` ;				    \
  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST ;							    \
    cvs remove $$OLDEST ;						    \
    set +x ;								    \
  fi ;									    \
									    \
  OLDEST=`ls daliclock*.prc | head -1` ;				    \
  /bin/echo -n "Delete $$DEST/$$OLDEST? ";					    \
  read line;								    \
  if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
    set -x ;								    \
    rm $$OLDEST $$OLDEST2 ;						    \
    cvs remove $$OLDEST $$OLDEST2 ;					    \
    set +x ;								    \
  fi ;									    \
									    \
  cat $$TMP > index.html ;						    \
  rm -f $$TMP ;								    \
									    \
  set -x ;								    \
  cvs add -kb $$TAR $$PRC $$DMG ;					    \
  cvs commit -m "$$VERS"

=== OSX/Makefile ===
--- 
+++ 
@@ -1,13 +1,13 @@
 # Dali Clock for MacOS X, Copyright (c) 2005-2007 by Jamie Zawinski.
 
-XCODEPROJ = All Targets
+XCODE_TARGET = "All Targets"
 
 default: release
 all: debug release
 
 clean:
 	-rm -rf build
-#	cd ..; xcodebuild -target "$(XCODEPROJ)" clean
+#	cd ..; xcodebuild -target $(XCODE_TARGET) clean
 
 distclean:
 	-rm -f config.status config.cache config.log \
@@ -16,15 +16,22 @@
 	-rm -rf build
 
 debug: distdepend
-	xcodebuild -target "$(XCODEPROJ)" -configuration Debug   build
+	xcodebuild -target $(XCODE_TARGET) -configuration Debug   build
 
-release: distdepend
-	xcodebuild -target "$(XCODEPROJ)" -configuration Release build
+release:: distdepend
+	xcodebuild -target $(XCODE_TARGET) -configuration Release build
+
+release:: sign
+
+sign:
+	codesign -vfs 'Jamie Zawinski' build/Release/*.{app,saver}
+	codesign -vfs 'Jamie Zawinski' build/Release/*.wdgt/*.widgetplugin
+#	codesign -vfs 'Jamie Zawinski' build/Release/*.wdgt
 
 echo_tarfiles:
 	@echo `find . \
 	  \( \( -name '.??*' -o -name build -o -name CVS -o -name '*~*' \
-	     -o -name 'jwz.*' \) \
+	     -o -name 'jwz.*' -o -name '*.widgetplugin' \) \
 	     -prune \) \
 	  -o -type f -print \
 	| sed 's@^\./@@' \
@@ -53,11 +60,12 @@
 
 distdepend:: update_plist_version
 update_plist_version:
-	@SS="AppInfo.plist SaverInfo.plist";				    \
+	@\
+  SS="AppInfo.plist SaverInfo.plist PluginInfo.plist *.wdgt/Info.plist" ;   \
   SRC=../version.h ;							    \
   V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' $$SRC` ;		    \
   for S in $$SS ; do							    \
-   echo -n "Updating version number in $$S to \"$$V\"... " ;		    \
+   /bin/echo -n "Updating version number in $$S to \"$$V\"... " ;	    \
    T=/tmp/xs.$$$$ ;							    \
    KEYS1="CFBundleVersion|CFBundleShortVersionString" ;			    \
    KEYS2="NSHumanReadableCopyright|CFBundleLongVersionString|CFBundleGetInfoString" ; \
@@ -84,7 +92,7 @@
   V=`echo $$V | sed 's/\.//g'` ;					      \
   TMPDIR="build" ;							      \
   SRC="build/Release" ;							      \
-  BASE="daliclock-$$V" ;						      \
+  BASE="DaliClock-$$V" ;						      \
   OUTDIR="../archive" ;							      \
   DMG="$$OUTDIR/$$BASE.dmg" ;						      \
   TMPDMG="$$TMPDIR/tmp.dmg" ;						      \
@@ -94,16 +102,19 @@
   rm -rf "$$STAGE" ;							      \
   echo + mkdir "$$STAGE" ;						      \
          mkdir "$$STAGE" ;						      \
-  FILES="$$SRC/*.app $$SRC/*.saver ../palm/daliclock.prc" ;		      \
+  FILES="$$SRC/*.app $$SRC/*.saver $$SRC/*.wdgt ../palm/daliclock.prc" ;      \
   echo + cp -pr $$FILES "$$STAGE" ;					      \
          cp -pr $$FILES "$$STAGE" ;					      \
   set -x ;								      \
   cp -p bindist.rtf "$$STAGE/ READ ME.rtf" ;				      \
   cp -p bindist-DS_Store "$$STAGE/.DS_Store" ;				      \
   /Developer/Tools/SetFile -a E "$$STAGE/ READ ME.rtf" ;		      \
-  /Developer/Tools/SetFile -a e $$STAGE/*.saver $$STAGE/*.prc ;		      \
+  /Developer/Tools/SetFile -a e $$STAGE/*.saver ;			      \
+  /Developer/Tools/SetFile -a e $$STAGE/*.prc ;				      \
+  /Developer/Tools/SetFile -a e $$STAGE/*.wdgt ;			      \
   seticon -d daliclockPRC.icns $$STAGE/*.prc ;				      \
   seticon -d daliclockSaver.icns $$STAGE/*.saver ;			      \
+  seticon -d daliclockWidget.icns $$STAGE/*.wdgt ;			      \
   hdiutil makehybrid -quiet -ov -hfs -hfs-volume-name "$$VOLNAME"	      \
     -hfs-openfolder "$$STAGE" "$$STAGE" -o "$$TMPDMG" ;			      \
   rm -rf "$$STAGE" ;							      \

## xdaliclock 2.34+debian

=== Makefile ===
--- 
+++ 
@@ -7,17 +7,15 @@
 NUMBERS		= numbers0/*.xbm numbers1/*.xbm numbers2/*.xbm \
 		  numbers_big/README numbers_big/*.gif numbers_big/*.xbm
 TAR		= tar
-COMPRESS	= gzip --verbose --best
-COMPRESS_EXT	= gz
 
 
 default:
 	@echo ''; \
-	 echo '        please make one of: "x", "palm", "all", or "clean"'; \
+	 echo '        please make one of: "x", "palm", "webos", "all", or "clean"'; \
 	 echo ''; \
 	 exit 5
 
-all: X11 palm
+all:: OSX webos palm X11
 
 X11::   x11
 X::     X11
@@ -25,8 +23,7 @@
 gtk::   GTK
 OSX::   osx
 palm::  Palm
-pilot:: Palm
-Pilot:: Palm
+webos:: WebOS
 
 x11:: X11/Makefile
 	@echo '==============================================================='
@@ -47,6 +44,11 @@
 	@echo '==============================================================='
 	@echo ''
 	cd palm ; make
+
+WebOS:: webos/Makefile
+	@echo '==============================================================='
+	@echo ''
+	cd webos ; make
 
 X11/Makefile:
 	@echo '==============================================================='
@@ -68,12 +70,14 @@
 	cd gtk ; make $@
 	cd OSX ; make $@
 	cd palm ; make $@
+	cd webos ; make $@
 
 distclean: X11/Makefile gtk/Makefile palm/Makefile
 	cd X11 ; make $@
 	cd gtk ; make $@
 	cd OSX ; make $@
 	cd palm ; make $@
+	cd webos ; make $@
 
 install:
 	@echo ''; \
@@ -83,29 +87,36 @@
 	 echo '        then copy "build/Development/DaliClock.app"';	     \
 	 echo '        to your Applications folder."';			     \
 	 echo ''; \
-	 echo '      - to install the Palm version: "cd palm; make", and';   \
+	 echo '      - to install the PalmOS version: "cd palm; make", and'; \
 	 echo '        then download "daliclock.prc" to your PalmOS device.';\
 	 echo ''; \
+	 echo '      - to install the WebOS version: "cd webos; make", and'; \
+	 echo '        then send the .ipk to your Palm WebOS device.';\
+	 echo ''; \
 	 exit 5
 
-tar: X11/Makefile gtk/Makefile palm/Makefile
+dmg::
+	cd OSX ; $(MAKE) dmg
+
+tar: X11/Makefile gtk/Makefile palm/Makefile dmg
 	@								    \
   for dir in X11 gtk palm ; do						    \
    ( cd $$dir ;								    \
      rm -f configure ;							    \
-     autoconf ;								    \
+     autoconf263 ;							    \
      ./config.status ;							    \
      $(MAKE) distdepend );						    \
   done ;								    \
   (cd X11; make update_spec_version) ;					    \
   (cd gtk; make update_spec_version) ;					    \
   (cd palm; make update_rsc_version) ;					    \
+  (cd webos; make update_release_date) ;				    \
   (cd OSX; make update_plist_version) ;					    \
   NAME=`sed -n								    \
   's/[^0-9]*\([0-9]\.[0-9][0-9]*\).*/xdaliclock-\1/p' version.h` ;	    \
   rm -rf $$NAME ; ln -s . $$NAME ;					    \
   FILES= ;								    \
-  for subdir in X11 gtk palm OSX ; do					    \
+  for subdir in X11 gtk palm OSX webos ; do				    \
     d=`pwd` ;								    \
     cd $$subdir ;							    \
     FILES="$$FILES `$(MAKE) echo_tarfiles				    \
@@ -113,13 +124,12 @@
       | sed \"s|^|$$subdir/|g;s| | $$subdir/|g\"			    \
       ` ";								    \
     cd $$d ; done ;							    \
-  echo creating tar file archive/$${NAME}.tar.$(COMPRESS_EXT)... ;	    \
-  $(TAR) -vchf -							    \
+  echo creating tar file archive/$${NAME}.tar.gz... ;			    \
+  GZIP="-9v" $(TAR) -vchzf archive/$${NAME}.tar.gz			    \
     `echo $(TARFILES) $$FILES $(NUMBERS)				    \
-   | sed "s|^|$$NAME/|g; s| | $$NAME/|g" `				    \
-   | $(COMPRESS) > archive/$${NAME}.tar.$(COMPRESS_EXT) ;		    \
+   | sed "s|^|$$NAME/|g; s| | $$NAME/|g" ` ;				    \
   rm $$NAME ;								    \
-  ls -ldF archive/$${NAME}.tar.$(COMPRESS_EXT)
+  ls -ldF archive/$${NAME}.tar.gz
 
 www::
 	@								    \
@@ -130,7 +140,6 @@
   HEAD2="daliclock-$$VERS2"						 ;  \
   HEAD3="DaliClock-$$VERS2"						 ;  \
   TAR="x$$HEAD.tar.gz"							 ;  \
-  PRC="$$HEAD2.prc"							 ;  \
   DMG="$$HEAD3.dmg"							 ;  \
 									    \
   if [ ! -f archive/$$TAR ]; then					    \
@@ -153,14 +162,6 @@
     fi ;								    \
   fi ;									    \
 									    \
-  if [ -f $$DEST/$$PRC ]; then						    \
-    /bin/echo -n "WARNING: $$DEST/$$PRC already exists!  Overwrite? ";	    \
-    read line;								    \
-    if [ "x$$line" != "xyes" -a "x$$line" != "xy" ]; then		    \
-      exit 1 ; 								    \
-    fi ;								    \
-  fi ;									    \
-									    \
   if [ -f $$DEST/$$DMG ]; then						    \
     /bin/echo -n "WARNING: $$DEST/$$DMG already exists!  Overwrite? ";	    \
     read line;								    \
@@ -175,7 +176,6 @@
   cp -p archive/$$DMG $$DEST/$$DMG ;					    \
   chmod u+w $$DEST/$$DMG ;						    \
 									    \
-  cp -p palm/daliclock.prc $$DEST/$$PRC ;				    \
   cd $$DEST ;								    \
 									    \
   TMP=/tmp/xd.$$$$ ;							    \
@@ -197,8 +197,8 @@
     set +x ;								    \
   fi ;									    \
 									    \
-  OLDEST=`ls daliclock*.prc | head -1` ;				    \
-  /bin/echo -n "Delete $$DEST/$$OLDEST? ";					    \
+  OLDEST=`ls DaliClock*.dmg | head -1` ;				    \
+  /bin/echo -n "Delete $$DEST/$$OLDEST? ";				    \
   read line;								    \
   if [ "x$$line" = "xyes" -o "x$$line" = "xy" ]; then			    \
     set -x ;								    \
@@ -211,6 +211,6 @@
   rm -f $$TMP ;								    \
 									    \
   set -x ;								    \
-  cvs add -kb $$TAR $$PRC $$DMG ;					    \
+  cvs add -kb $$TAR $$DMG ;						    \
   cvs commit -m "$$VERS"

=== OSX/Makefile ===
# Dali Clock for MacOS X, Copyright (c) 2005-2007 by Jamie Zawinski.

XCODE_TARGET = "All Targets"

default: release
all: debug release

clean:
	-rm -rf build
#	cd ..; xcodebuild -target $(XCODE_TARGET) clean

distclean:
	-rm -f config.status config.cache config.log \
	  *.bak *.rej TAGS *~ "#"*
	-rm -rf autom4te*.cache
	-rm -rf build

distdepend:: update_plist_version
distdepend:: update_bindist_version

debug: distdepend
	xcodebuild -target $(XCODE_TARGET) -configuration Debug   build

release:: distdepend
	xcodebuild -target $(XCODE_TARGET) -configuration Release build

release:: check_versions

release:: sign


distdepend:: DaliClockPhone72.png DaliClockPhone57.png
distdepend:: DaliClockPhone50.png DaliClockPhone29.png
DaliClockPhone72.png: iTunesArtwork
	convert -resize '72x72!' $< $@
DaliClockPhone57.png: iTunesArtwork
	convert -resize '57x57!' $< $@
DaliClockPhone50.png: iTunesArtwork
	convert -resize '50x50!' $< $@
DaliClockPhone29.png: iTunesArtwork
	convert -resize '29x29!' $< $@


CERT='iPhone Developer: Jamie Zawinski (Y5M82TL69N)'
sign:
	codesign -vfs $(CERT) build/Release/*.app
	codesign -vfs $(CERT) build/Release/*.saver
	codesign -vfs $(CERT) build/Release/*.wdgt/*.widgetplugin
#	codesign -vfs $(CERT) build/Release/*.wdgt
	codesign -vfs $(CERT) build/Release-iphoneos/*.app

check_versions:
	@\
  U=../version.h ;							\
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		\
  DIR=build/Release ;							\
  RESULT=0 ;								\
  for P in `find $$DIR -name Info.plist` ; do				\
     V2=`perl -0000 -n -e						\
	'm@<key>CFBundleVersion</key>\s*<string>(.*?)</string>@si 	\
	 && print $$1' < $$P` ;						\
     if [ "$$V2" != "$$V" ] ; then					\
       echo "Wrong version: $$P ($$V2)" ;				\
       RESULT=1 ;							\
     fi ;								\
  done ;								\
  if [ "$$RESULT" = 0 ]; then echo "Versions match ($$V2)" ; fi ;	\
  exit $$RESULT


echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name build -o -name CVS -o -name '*~*' \
	     -o -name 'jwz.*' -o -name '*.widgetplugin' \
	     -o -name '*.psd' -o -name '*.ai' \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`

update_plist_version:
	@								      \
  SS="AppInfo.plist SaverInfo.plist PluginInfo.plist iPhoneInfo.plist *.wdgt/Info.plist" ;   \
  SRC=../version.h ;							      \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ]*\).*/\1/p' $$SRC` ;		      \
  Y=`date +%Y` ;							      \
  T=/tmp/xs.$$$$ ;							      \
  for S in $$SS ; do							      \
    /bin/echo -n "Updating version number in $$S to \"$$V\"... " ;	      \
    KEYS1="CFBundleVersion|CFBundleShortVersionString" ;		      \
    KEYS2="NSHumanReadableCopyright|CFBundleLongVersionString|CFBundleGetInfoString" ; \
    perl -0777 -pne							      \
      "s@(<key>($$KEYS1)</key>\s*<string>)[^<>]+(</string>)@\$${1}$$V\$${3}@g; \
       s@(<key>($$KEYS2)</key>\s*<string>[^\d]+)[\d.]+(.*?</string>)@\$${1}$$V\$${3}@gs; \
       s@(<key>($$KEYS2)</key>\s*<string>.*?1991-)\d\d\d\d(.*?</string>)@\$${1}$$Y\$${3}@gs" \
    < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
     echo "unchanged." ;						    \
   else									    \
    cat $$T > $$S ;							    \
    echo "done." ;							    \
   fi ;									    \
   rm $$T ;								    \
  done


update_bindist_version:
	@								    \
  SS="bindist.rtf" ;							    \
  U=../version.h ;							    \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' < $$U` ;		    \
  D=`date '+%d-%b-%Y'` ;						    \
  for S in $$SS ; do							    \
   T=/tmp/xs.$$$$ ;							    \
   sed -e "s/\(.*version \)[0-9][0-9]*\.[0-9]*[ab]*[0-9]*\(.*\)/\1$$V\2/"   \
       -e "s/\([0-9][0-9]-[A-Z][a-z][a-z]-[0-9][0-9][0-9]*\)/$$D/"	    \
      < $$S > $$T ;							    \
   if cmp -s $$S $$T ; then						    \
    true ;								    \
   else									    \
    cat $$T > $$S ;							    \
    echo "updated $$S to $$V $$D" ;					    \
   fi ;									    \
  done ;								    \
  rm $$T

# -format UDBZ saves 4% over UDZO, but that's only 8KB.
dmg:: distdepend check_versions
	@								      \
  set -e ;								      \
  SRC=../version.h ;							      \
  V=`sed -n 's/[^0-9]*\([0-9]\.[0-9][^. ;]*\).*/\1/p' $$SRC` ;		      \
  V2="$$V" ;								      \
  V=`echo $$V | sed 's/\.//g'` ;					      \
  TMPDIR="build" ;							      \
  SRC="build/Release" ;							      \
  BASE="DaliClock-$$V" ;						      \
  OUTDIR="../archive" ;							      \
  DMG="$$OUTDIR/$$BASE.dmg" ;						      \
  TMPDMG="$$TMPDIR/tmp.dmg" ;						      \
  VOLNAME="DaliClock $$V2" ;						      \
  STAGE="$$TMPDIR/dmg_stage" ;						      \
  rm -f "$$DMG" ;							      \
  rm -rf "$$STAGE" ;							      \
  echo + mkdir "$$STAGE" ;						      \
         mkdir "$$STAGE" ;						      \
  FILES="$$SRC/*.app $$SRC/*.saver $$SRC/*.wdgt" ;			      \
  echo + cp -pr $$FILES "$$STAGE" ;					      \
         cp -pr $$FILES "$$STAGE" ;					      \
  set -x ;								      \
  cp -p bindist.rtf "$$STAGE/ READ ME.rtf" ;				      \
  cp -p bindist-DS_Store "$$STAGE/.DS_Store" ;				      \
  cp -p bindist.webloc "$$STAGE/DaliClock for iPhone:iPad.webloc" ;	      \
  /Developer/Tools/SetFile -a E "$$STAGE/ READ ME.rtf" ;		      \
  /Developer/Tools/SetFile -a e $$STAGE/*.saver ;			      \
  /Developer/Tools/SetFile -a e $$STAGE/*.wdgt ;			      \
  /Developer/Tools/SetFile -a E $$STAGE/*.webloc ;			      \
  seticon -d daliclockSaver.icns $$STAGE/*.saver ;			      \
  seticon -d daliclockWidget.icns $$STAGE/*.wdgt ;			      \
  seticon -d daliclock.icns $$STAGE/*.webloc ;				      \
  hdiutil makehybrid -quiet -ov -hfs -hfs-volume-name "$$VOLNAME"	      \
    -hfs-openfolder "$$STAGE" "$$STAGE" -o "$$TMPDMG" ;			      \
  rm -rf "$$STAGE" ;							      \
  hdiutil convert -quiet -ov -format UDZO -imagekey zlib-level=9	      \
    "$$TMPDMG" -o "$$DMG" ;						      \
  rm -f "$$TMPDMG" ;							      \
  ls -ldhgF "$$DMG"

# Adding this is cute:
#    hdiutil internet-enable -yes -quiet "$$DMG"
# but means that nobody will ever see the display settings I used!
# When finder copies the .dmg to a folder, it doesn't preserve them.

=== webos/Makefile ===
# Dali Clock for Palm WebOS, Copyright (c) 2009 by Jamie Zawinski.

TITLE		= Dali Clock
TARGET		= DaliClock
TARGET2		= daliclock
VENDOR		= Jamie Zawinski
VERSION		= $(shell sed -n \
			's/^.*v\([0-9][0-9]*\.[0-9][0-9]*\).*$$/\1.0/p' \
			< ../version.h)
ID		= org.jwz.$(TARGET2)
IPK		= $(ID)_$(VERSION)_all.ipk
DEVDIR		= /opt/PalmSDK/Current/bin
DEVICE		= tcp
CERT		= cert.pem

CC		= gcc
CFLAGS		= -g -Wall -Wstrict-prototypes -Wnested-externs
LDFLAGS		= 
DEFINES		= -DBUILTIN_FONTS
INCLUDES	= -I. -I../numbers_big -I../OSX
OBJS		= buildnumbers.o

FONTDIR		= $(TARGET)/images
NUMBERS		= $(FONTDIR)/font0.json \
		  $(FONTDIR)/font1.json \
		  $(FONTDIR)/font2.json \
		  $(FONTDIR)/font3.json \
		  $(FONTDIR)/font4.json \
		  $(FONTDIR)/font5.json

default: ipk

clean:
	rm -f *.o buildnumbers

distclean: clean
	find . \( \
	  -name '*.bak' -o -name '*.rej' -o -name '*~' -o -name '#*' \
	  \) -exec rm '{}' \;

distdepend:: update_release_date

echo_tarfiles:
	@echo `find . \
	  \( \( -name '.??*' -o -name CVS -o -name '*~*' -o -name '*.o' \
		-o -name buildnumbers -o -name '*.pem' -o -name '*.ipk' \
		-o -name '*.jpg' \
	      \) \
	     -prune \) \
	  -o -type f -print \
	| sed 's@^\./@@' \
	| sort`


.c.o:
	$(CC) -c $(INCLUDES) $(DEFINES) $(CFLAGS) $<

buildnumbers: buildnumbers.o
	$(CC) $(LDFLAGS) -o $@ $(OBJS)

$(NUMBERS): buildnumbers

$(FONTDIR)/font0.json:
	./buildnumbers 0 > $@
$(FONTDIR)/font1.json:
	./buildnumbers 1 > $@
$(FONTDIR)/font2.json:
	./buildnumbers 2 > $@
$(FONTDIR)/font3.json:
	./buildnumbers 3 > $@
$(FONTDIR)/font4.json:
	./buildnumbers 4 > $@
$(FONTDIR)/font5.json:
	./buildnumbers 5 > $@

all:: $(NUMBERS)


# Create cert.pem with:
#  openssl req -x509 -nodes -days 3650 -newkey rsa:1024 \
#   -keyout cert.pem -out cert.pem
# Keep that file secret!  It is your private key.

sign:
	@\
  if [ ! -f "$(CERT)" ]; then						      \
    echo "$(CERT) does not exist! Generate one. See Makefile." ;	      \
    exit 1 ;								      \
  fi ;									      \
  /bin/echo -n "Generating signature for \"$(IPK)\"... " ;		      \
  STAGE=sign-$$$$ ;							      \
  rm -rf $$STAGE ;							      \
  mkdir $$STAGE ;							      \
  cd $$STAGE ;								      \
  PUBKEY=pubkey.pem ;							      \
  SIG=signature.sha1 ;							      \
  openssl rsa -in ../$(CERT) -pubout -out $$PUBKEY 2>/dev/null ;	      \
  ar -x ../$(IPK) ;							      \
  FILES="control.tar.gz data.tar.gz debian-binary" ;			      \
  cat $$FILES | openssl dgst -sha1 -sign ../$(CERT) -out $$SIG ;	      \
  cat $$FILES | openssl dgst -sha1 -verify $$PUBKEY -signature $$SIG ;	      \
  FILES="$$FILES $$PUBKEY $$SIG" ;					      \
  touch -r ../$(IPK) $$FILES ;						      \
  ar -cr $(IPK) $$FILES ;						      \
  if cmp -s $(IPK) ../$(IPK) ; then					      \
    echo "Unchanged." ;							      \
  else									      \
    cat $(IPK) > ../$(IPK) ;						      \
    echo "Signature installed." ;					      \
  fi ;									      \
  cd .. ;								      \
  rm -rf $$STAGE


ipk: $(NUMBERS) ../version.h update_release_date
	$(DEVDIR)/palm-package --exclude CVS --exclude '*~' $(TARGET)
	$(MAKE) sign


update_release_date::
	@S="$(TARGET)/appinfo.json" ;					      \
  DATE=`date +%d-%h-%Y` ;						      \
  /bin/echo -n "Updating version in $$S to $(VERSION)/$$DATE... " ;	      \
  T=/tmp/xs.$$$$ ;							      \
  sed -e "s/^\(.*\"release_date\":.*\"\).*\(\".*\)$$/\1$$DATE\2/"	      \
      -e "s/^\(.*\"version\":.*\"\).*\(\".*\)$$/\1$(VERSION)\2/"	      \
     < $$S > $$T ;							      \
  if cmp -s $$S $$T ; then						      \
    echo "unchanged." ;							      \
  else									      \
    cat $$T > $$S ;							      \
    echo "done." ;							      \
  fi ;									      \
  rm $$T


palm-generate-app:
	@								      \
  if [ -d $(TARGET) ]; then						      \
    echo "$(TARGET)/ already exists" ;					      \
    exit 1 ;								      \
  fi
	$(DEVDIR)/palm-generate \
	  -p "{title:'$(TITLE)', id:$(ID), version:'$(VERSION)'}" $(TARGET)
	perl -pi -e 's/My Company/$(VENDOR)/g' $(TARGET)/appinfo.json

palm-generate-scene:
	@D=$(TARGET)/app/views/clock ;					      \
  if [ -d $$D ]; then							      \
    echo "$$D/ already exists" ;					      \
    exit 1 ;								      \
  fi
	$(DEVDIR)/palm-generate -t new_scene -p "name=Clock" $(TARGET)


palm-install:
	$(DEVDIR)/palm-install -d $(DEVICE) $(IPK)

palm-launch:
	$(DEVDIR)/palm-launch -d $(DEVICE) $(ID)

palm-kill:
	$(DEVDIR)/palm-launch -d $(DEVICE) -c $(ID) ; exit 0

reset-emulator:
	killall VirtualBoxVM
	rm $$HOME/Library/VirtualBox/Machines/Palm*/*.xml

test:: ipk palm-kill palm-install palm-launch

=== debian/changelog ===
xdaliclock (2.34+debian-1) unstable; urgency=low

  * New upstream release
  * debian/copyright:
    + Better debian/* copyright section

 -- Kartik Mistry <kartik@debian.org>  Wed, 09 Jun 2010 17:23:42 +0530

xdaliclock (2.33+debian-1) unstable; urgency=low

  * New upstream release:
    + Dropped spelling-error-in-manpage_xdaliclock patch, fixed upstream
  * We repack upstream tarball, so adding +debian suffix in package version
  * debian/watch:
    + Updated for dversionmangle
  * debian/control:
    + Wrapped up long description
  * debian/copyright:
    + Updated as per DEP-5 specifications

 -- Kartik Mistry <kartik@debian.org>  Wed, 19 May 2010 17:32:03 +0530

xdaliclock (2.31-1) unstable; urgency=low

  * New maintainer (Closes: #561233)
  * New upstream release (Closes: #578379)
  * debian/control:
    + Updated to Standards-Version 3.8.4
    + Added ${misc:Depends} to Depends
    + Updated debhelper dependency to 7
  * debian/rules:
    + Do not do append to copyright file trick
    + Used dh_prep instead of dh_clean -k
  * Converted package to new source format 3.0 (quilt)
  * debian/copyright:
    + Added missing vroot.h copyright
    + Better copyright assignment, year for Author
  * debian/patches/spelling-error-in-manpage_xdaliclock:
    + Added patch to fix manpage spelling mistake by Florian Ernst
      <florian@debian.org>

 -- Kartik Mistry <kartik@debian.org>  Tue, 20 Apr 2010 08:42:20 +0530

xdaliclock (2.25-1) unstable; urgency=low

  * New upstream release
  * Do the menu transition: Apps/Tools -> Games/Toys
  * Make use of Homepage control field

 -- Florian Ernst <florian@debian.org>  Sun, 02 Dec 2007 11:28:00 +0100

xdaliclock (2.24-1) unstable; urgency=low

  * New upstream release
  * debian/control: B-D on x11proto-core-dev instead of x-dev
  * Standards-Version 3.7.2

 -- Florian Ernst <florian@debian.org>  Sat, 05 May 2007 11:18:25 +0200

xdaliclock (2.23-1) unstable; urgency=low

  * New maintainer (Closes: #353390)
    + minor packaging tweaking, including auto-update of config.{sub,guess}
    + fix changelog weirdness
    + update debhelper compatibility level and Standards-Version
  * New upstream release
  * Remove patch from 2.18-9 as it seems to cause problems, this will
    supposedly fix #246572: xdaliclock freezes randomly
  * Acknowledge previous NMU via -v2.20-1

 -- Florian Ernst <florian@debian.org>  Fri, 24 Feb 2006 11:48:26 +0100

xdaliclock (2.20-1.1) unstable; urgency=low

  * Non-maintainer upload for xlibs-dev transition.
  * Update debian/control to not build-depend on xlibs-dev. (Closes: #346805)
  * Update config.{sub,guess} to fix FTBFS on k*BSD. (Closes: #342434)

 -- Marc 'HE' Brockschmidt <he@debian.org>  Thu, 19 Jan 2006 00:51:15 +0100

xdaliclock (2.20-1) unstable; urgency=low

  * New upstream version fixes Xinerama problems (Closes: #217684)

 -- Aaron Lehmann <aaronl@vitelus.com>  Sun, 21 Dec 2003 22:19:11 -0800

xdaliclock (2.19-1) unstable; urgency=low

  * New upstream version (Closes: #196312)

 -- Aaron Lehmann <aaronl@vitelus.com>  Thu, 05 Jun 2003 19:48:26 -0700

xdaliclock (2.18-9) unstable; urgency=low

  * Apply patch from Zack Weinberg <zackw@panix.com> to only wake up once a
    minute when in no-seconds mode and color cycling is off.

 -- Aaron Lehmann <aaronl@vitelus.com>  Mon,  8 Oct 2001 12:18:39 -0700

xdaliclock (2.18-8) unstable; urgency=low

  * Document -datemode option in manual page and refer to the explaination there in usage() output. (Closes: 82585)
  * Fix time.h includes to allow compilation with recent versions of libc

 -- Aaron Lehmann <aaronl@vitelus.com>  Tue, 20 Feb 2001 01:48:35 -0800

xdaliclock (2.18-7) unstable; urgency=low

  * New maintainer (Closes: #82249)
  * Updated Build-Depends to depend on modern X packages
  * Removed dh_suidregister from debian/rules file

 -- Aaron Lehmann <aaronl@vitelus.com>  Sun, 14 Jan 2001 10:34:50 -0800

xdaliclock (2.18-5) unstable; urgency=low

  * Moved a man page, Closes: #80777 (serious?)

 -- Joey Hess <joey@kitenet.net>  Thu, 28 Dec 2000 14:43:37 -0800

xdaliclock (2.18-4) unstable; urgency=low

  * Added menu hint, Closes: #51995.

 -- Joey Hess <joeyh@debian.org>  Mon,  6 Dec 1999 13:32:56 -0800

xdaliclock (2.18-3) unstable; urgency=low

  * Build deps.

 -- Joey Hess <joeyh@debian.org>  Sat,  4 Dec 1999 18:15:10 -0800

xdaliclock (2.18-2) unstable; urgency=low

  * Allow freshly unpacked source to be cleaned, Closes: #51700

 -- Joey Hess <joeyh@debian.org>  Wed,  1 Dec 1999 13:11:10 -0800

xdaliclock (2.18-1) unstable; urgency=low

  * New upstream source.
  * Changes to debian/rules for new build system.

 -- Joey Hess <joeyh@debian.org>  Mon, 29 Nov 1999 13:17:17 -0800

xdaliclock (2.14-3) unstable; urgency=low

  * Removed install-stamp target, which can cause some problems.

 -- Joey Hess <joeyh@debian.org>  Thu, 30 Sep 1999 13:35:54 -0700

xdaliclock (2.14-2) unstable; urgency=low

  * FHS

 -- Joey Hess <joeyh@debian.org>  Mon, 20 Sep 1999 21:07:09 -0700

xdaliclock (2.14-1) unstable; urgency=low

  * New upstream release (#34513). Probably fixes #18324 as well.
  * Debhelperized. This has a side effect of removing the *~ files
    that have crept into the .diff.
  * Registered with menu system (#35840).
  * Updated download location in copyright file.

 -- Joey Hess <joeyh@debian.org>  Sun, 11 Apr 1999 14:39:22 -0700

xdaliclock (2.11-3) frozen unstable; urgency=low

  * Now maintained by a different Joey.

 -- Joey Hess <joeyh@debian.org>  Sun, 11 Apr 1999 01:46:20 -0700

xdaliclock (2.11-2) frozen unstable; urgency=medium

  * used $(installdoc) on changelog (lintian)

 -- Martin Schulze <joey@finlandia.infodrom.north.de>  Tue, 24 Mar 1998 00:07:37 +0100

xdaliclock (2.11-1) unstable; urgency=low

  * New upstream version (thanks Joey!!) (closes: Bug#17998)
  * New Standards-Version 2.4.0.0 (lintian)
  * Corrected source location in copyright file



=== debian/control ===
Source: xdaliclock
Section: x11
Priority: optional
Build-Depends: debhelper (>= 7),
               autotools-dev,
               libx11-dev,
               libxext-dev,
               libxt-dev,
               x11proto-core-dev
Maintainer: Kartik Mistry <kartik@debian.org>
Standards-Version: 3.8.4
Homepage: http://www.jwz.org/xdaliclock/

Package: xdaliclock
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Melting digital clock
 The xdaliclock program displays a digital clock; when a digit changes, it
 "melts" into its new shape.
 .
 It can display in 12 or 24 hour modes, and displays the date when a mouse
 button is held down. It has two large fonts built into it, but it can animate
 most other fonts that contain all of the digits. It can also do some funky
 psychedelic colormap cycling, and can use the "shape" extension so that the
 window is shaped like the digits.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.

#export DH_VERBOSE=1

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

build: build-stamp
build-stamp:
	dh_testdir
	ln -sf /usr/share/misc/config.sub config.sub
	ln -sf /usr/share/misc/config.guess config.guess
	cd X11 && ( CFLAGS="$(CFLAGS)" ./configure \
		--host=$(DEB_HOST_GNU_TYPE) --build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr --mandir=/usr/share/man )
	cd X11 && $(MAKE) CFLAGS="$(CFLAGS)"
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f X11/Makefile ] || ( cd X11 && $(MAKE) distclean )
	dh_clean config.sub config.guess

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs usr/share/man/man1 usr/bin
	cd X11 && $(MAKE) install_prefix=$(CURDIR)/debian/xdaliclock install

binary-indep: build install
# We have nothing to do by default.

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs README
	dh_installmenu
	dh_installman
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
